#include"TFT.h"

void set_point(u16 x, u16 y, u16 color)
{
	wr_reg(0x0020, x);
	wr_reg(0x0021, y);
	wr_com(0x22);
	wr_da(color);
}

u16 read_point(u16 x, u16 y)
{
	u16 t;

	wr_reg(0x0020, x);
	wr_reg(0x0021, y);
	wr_com(0x22);

	GPIOB->CRH = 0x88888888;
	GPIOB->CRL = 0x88888888;
	GPIOB->ODR = 0xffff;

	rs = 1;
	cs = 0;

	rd = 0;
	rd = 1;

	rd = 0;
	rd = 1;

	t = GPIOB->IDR;
	cs = 1;

	GPIOB->CRH = 0x33333333;
	GPIOB->CRL = 0x33333333;
	GPIOB->ODR = 0xffff;

	return LCD_BGR2RGB(t);
}

u16 LCD_BGR2RGB(u16 c)
{
	u16  r,g,b,rgb;   
	b=(c>>0)&0x1f;
	g=(c>>5)&0x3f;
	r=(c>>11)&0x1f;	 
	rgb=(b<<11)+(g<<5)+(r<<0);		 
	return(rgb);
}

void dis_str(u16 x0, u16 y0, u16 qj, u16 bj, u8 *str)
{
	u16 i = 0;

	while(1)
	{
		if (str[i] == '\0') break;
		dis_char(x0 + i*8, y0, qj, bj, str[i]);
		i++;	
	}
}

void dis_num(u16 x0, u16 y0, u16 qj, u16 bj, u8 da)
{
	u16 i, j;
	u8 temp1, temp2;

	wr_reg(0x0050, x0);	//xĿʼ
	wr_reg(0x0051, x0 + 7);	//xĽ
	
	wr_reg(0x0052, y0);	//yĿʼ
	wr_reg(0x0053, y0 + 15);	//yĽ
	
	wr_reg(0x0020, x0);	//֪xĿʼ
	wr_reg(0x0021, y0);	//ʾyĿʼ
	wr_com(0x22);		//׼򴰿д

	for (j = 0; j < 16; j++)
	{
		temp1 = ascii[da + 0x10][j];
		for (i = 0; i < 8; i++)
		{
			temp2 = temp1 & 0x01;
			if (temp2)
				wr_da(qj);
			else
				wr_da(bj);
			temp1 = temp1 >> 1;
		}
	}
	wr_reg(0x0050, 0);	//xĿʼ
	wr_reg(0x0051, 239);	//xĽ
	
	wr_reg(0x0052, 0);	//yĿʼ
	wr_reg(0x0053, 319);	//yĽ
	
	wr_reg(0x0020, 0);	//֪xĿʼ
	wr_reg(0x0021, 0);	//ʾyĿʼ
	wr_com(0x22);		//׼򴰿д
}

void dis_char(u16 x0, u16 y0, u16 qj, u16 bj, u8 da)
{
	u16 i, j;
	u8 temp1, temp2;

	wr_reg(0x0050, x0);	//xĿʼ
	wr_reg(0x0051, x0 + 7);	//xĽ
	
	wr_reg(0x0052, y0);	//yĿʼ
	wr_reg(0x0053, y0 + 15);	//yĽ
	
	wr_reg(0x0020, x0);	//֪xĿʼ
	wr_reg(0x0021, y0);	//ʾyĿʼ
	wr_com(0x22);		//׼򴰿д

	for (j = 0; j < 16; j++)
	{
		temp1 = ascii[da - 0x20][j];
		for (i = 0; i < 8; i++)
		{
			temp2 = temp1 & 0x01;
			if (temp2)
				wr_da(qj);
			else
				wr_da(bj);
			temp1 = temp1 >> 1;
		}
	}
	wr_reg(0x0050, 0);	//xĿʼ
	wr_reg(0x0051, 239);	//xĽ
	
	wr_reg(0x0052, 0);	//yĿʼ
	wr_reg(0x0053, 319);	//yĽ
	
	wr_reg(0x0020, 0);	//֪xĿʼ
	wr_reg(0x0021, 0);	//ʾyĿʼ
	wr_com(0x22);		//׼򴰿д
}

void LCD_Clear(u16 color)
{
	u16 i, j;
	
	wr_reg(0x0020, 0);
	wr_reg(0x0021, 0);
	wr_com(0x22);
	for (i = 0; i < 320; i++)
		for (j = 0; j < 240; j++)
			wr_da(color);
}

void init_lcd(void)
{
	RCC->APB2ENR |= 1 << 0 | 1 << 3 | 1 << 4;
	JTAG_Set(SWD_ENABLE);  //SWD 
	GPIOB->CRL = 0x33333333;
	GPIOB->CRH = 0x33333333;
	GPIOB->ODR = 0xffff;

	GPIOC->CRH &= 0xfffff000;
	GPIOC->CRL &= 0x00ffffff;
	GPIOC->CRH |= 0x00000333;
	GPIOC->CRL |= 0x33000000;
	GPIOC->ODR |= 1 << 10 | 1 << 9 | 1 << 8 | 1 << 7 | 1 << 6;

	init_id();
}

void wr_com(u8 com)
{
	rs = 0;
	cs = 0;
	GPIOB->ODR = com;
	wr = 0;
	wr = 1;
	cs = 1;	
}

void wr_da(u16 da)
{
	rs = 1;
	cs = 0;
	GPIOB->ODR = da;
	wr = 0;
	wr = 1;
	cs = 1;	
}

void wr_reg(u8 com, u16 da)
{
	wr_com(com);
	wr_da(da);
}

void init_id(void)		//9328ʼ
{
    wr_reg(0x00e7,0x0010);      
    wr_reg(0x0000,0x0001);//ڲʱ
    wr_reg(0x0001,0x0100);     
    wr_reg(0x0002,0x0700);//Դ                    
	//LCD_WriteReg(0x0003,(1<<3)|(1<<4) ); 	//65K  RGB
	//DRIVE TABLE(Ĵ 03H)
	//BIT3=AM BIT4:5=ID0:1
	//AM ID0 ID1   FUNCATION
	// 0  0   0	   R->L D->U
	// 1  0   0	   D->U	R->L
	// 0  1   0	   L->R D->U
	// 1  1   0    D->U	L->R
	// 0  0   1	   R->L U->D
	// 1  0   1    U->D	R->L
	// 0  1   1    L->R U->D .
	// 1  1   1	   U->D	L->R
    wr_reg(0x0003,(1<<12)|(3<<4)|(0<<3) );//65K    
    wr_reg(0x0004,0x0000);                                   
    wr_reg(0x0008,0x0207);	           
    wr_reg(0x0009,0x0000);         
    wr_reg(0x000a,0x0000);//display setting         
    wr_reg(0x000c,0x0001);//display setting          
    wr_reg(0x000d,0x0000);//0f3c          
    wr_reg(0x000f,0x0000);
	//Դ
    wr_reg(0x0010,0x0000);   
    wr_reg(0x0011,0x0007);
    wr_reg(0x0012,0x0000);                                                                 
    wr_reg(0x0013,0x0000);                 
    delay_ms(50); 
    wr_reg(0x0010,0x1590);   
    wr_reg(0x0011,0x0227);
    delay_ms(50); 
    wr_reg(0x0012,0x009c);                  
    delay_ms(50); 
    wr_reg(0x0013,0x1900);   
    wr_reg(0x0029,0x0023);
    wr_reg(0x002b,0x000e);
    delay_ms(50); 
    wr_reg(0x0020,0x0000);                                                            
    wr_reg(0x0021,0x013f);           
	delay_ms(50); 
	//٤У
    wr_reg(0x0030,0x0007); 
    wr_reg(0x0031,0x0707);   
    wr_reg(0x0032,0x0006);
    wr_reg(0x0035,0x0704);
    wr_reg(0x0036,0x1f04); 
    wr_reg(0x0037,0x0004);
    wr_reg(0x0038,0x0000);        
    wr_reg(0x0039,0x0706);     
    wr_reg(0x003c,0x0701);
    wr_reg(0x003d,0x000f);
    delay_ms(50); 
    wr_reg(0x0050,0x0000); //ˮƽGRAMʼλ 
    wr_reg(0x0051,0x00ef); //ˮƽGRAMֹλ                    
    wr_reg(0x0052,0x0000); //ֱGRAMʼλ                    
    wr_reg(0x0053,0x013f); //ֱGRAMֹλ  
    
    wr_reg(0x0060,0xa700);        
    wr_reg(0x0061,0x0001); 
    wr_reg(0x006a,0x0000);
    wr_reg(0x0080,0x0000);
    wr_reg(0x0081,0x0000);
    wr_reg(0x0082,0x0000);
    wr_reg(0x0083,0x0000);
    wr_reg(0x0084,0x0000);
    wr_reg(0x0085,0x0000);
  
    wr_reg(0x0090,0x0010);     
    wr_reg(0x0092,0x0000);  
    wr_reg(0x0093,0x0003);
    wr_reg(0x0095,0x0110);
    wr_reg(0x0097,0x0000);        
    wr_reg(0x0098,0x0000);  
    //ʾ    
    wr_reg(0x0007,0x0133);   
    wr_reg(0x0020,0x0000);                                                            
    wr_reg(0x0021,0x013f);
}

void Set_Window(u16 x0, u16 y0, u16 x1, u16 y1)
{
	wr_reg(0x0050, x0);	//xĿʼ
	wr_reg(0x0051, x1);	//xĽ
	
	wr_reg(0x0052, y0);	//yĿʼ
	wr_reg(0x0053, y1);	//yĽ
	
	wr_reg(0x0020, x0);	//֪xĿʼ
	wr_reg(0x0021, y0);	//ʾyĿʼ
	wr_com(0x22);		//׼򴰿д
}
